
#ifndef GLOBAL_ROUTE_H
#define GLOBAL_ROUTE_H

#include "route.h"

/*---------------------------------------------------------------
* Local (to global_route.c)  Declarations
*---------------------------------------------------------------
*/
char net_under_study[32] = "not in use";
char dfname[40] = "temp";

net *Net = NULL;	/* Used as a temporary global */

FILE *df, *vf, *hf;     /* Where to dump the global route trace/debug info */

int currentPage;	/* The current page on which insertions are being made */

int (*set_congestion_value)();		 /* The congestion function being used */


/*--------------------------------------------------------------- 
 * Forward declarations defined in global_route.c
 *---------------------------------------------------------------
 */
expnlist *list_completed_subnetsA();
void prepare_tile_spaces();
void delete_trail();
void replace_trail();
trail *copy_trail();
void add_trail_copy();
trailist *remove_trailA();
trailist *remove_trailE();
tile *initial_move();
tile *locate_first_tile();

void kill_hashA(asg_arc *a);
int insert_trailA(trail *tr, asg_arc *a);
int trail_cost(trail *tr);
trlist *remove_all_trails_from_arc(asg_arc *a);
trail *make_startup_trail(expn *ex, tile *starTile, int page);
int trail_cost_est(tilist *tiles, expn *ex, int page, int *trailLength, int *trailEst, int *tileCount, int *trailCong);	
int terminal_spacer(term *t, int axis);
int break_cost_tie(trail *tr1, trail *tr2);

#endif // #ifndef GLOBAL_ROUTE_H