
#ifndef N2A_H
#define N2A_H

/*---------------------------------------------------------------
 * Global Variable Definitions
 *---------------------------------------------------------------
 */

mlist *modules;		/* M the set of all modules */
nlist *nets;		/* N the set of all nets */
tlist *ext_terms;	/* ST the set of all system terminals */
mlist *ext_mods;	/* the modules associated with each element of ST */

/* FOR THE ROUTER (only) */
int currentPartition;
tile **routingRoot[2];	  
/* NOT USED ENOUGH */
int lcount = 0;			   /* number of input lines read */
int module_count = 0;		   /* number of modules/objects read in */
int node_count = 0;		   /* number of nodes/signals read in */
int terminal_count = 0;		   /* number of terminals read in */
int connected[MAX_MOD][MAX_MOD];   /* BIG array of connection counts */
info_type module_info[MAX_MOD];/* re-used array of inter module connections */
float partition_ratio=DEF_PARTITION_RATIO; 	/* -r qualifier, used for clustering */
/* command-line parameters: */
int compute_aspect_ratios = FALSE;		/* -a flag, in parsing - compute aspect ratios*/
int Xcanvas_scaling = TRUE;	   		/* -b flag (use XCanvas scaling) */
int max_partition_conn =  MAX_PARTITION_CONN; 	/* -c qualifier, used for clustering */
int stopAtFirstCut = FALSE;			/* -f flag; terminates GR early */
int congestion_rule = 2; 			/* -g qualifier, used for conGestion */
int do_hand_placement = FALSE;			/* -h flag */
int includeSysterms = TRUE;			/* -i flag; excludes system terminals */

int cc_search_level = CC_SEARCH_LEVEL;		/* -l qualifier, limits cc search */
int matrix_type = UNSIGNED;			/* -m qualifier, sets signal-flow style*/
int do_routing = TRUE;				/* -n qualifier, inhibits routing */
FILE *lroutputFile = NULL;
FILE *groutputFile = NULL;
int partition_rule = DEF_PARTITION_RULE; 	/* -p qualifier, used for clustering */
int recordStats = FALSE;			/* -q flag; quality stats collection on*/
int max_partition_size =  MAX_PARTITION_SIZE; 	/* -s qualifier, used for clustering */
int useSlivering = FALSE;			/* -v flag; removes sliVer corrections */
int useAveraging = FALSE;			/* -w flag; turns Weighted averaging on*/
int latex = FALSE;				/* -x flag; modified PostScript header */
char *ivffilename = NULL; 			      	/* input file name */
FILE *stats = NULL;					/* quality statistics file */

/* NOT USED MUCH */
mlist **boxes = NULL;		/* the sets of boxes */
mlist **strings = NULL;	/* the set of strings */
ctree **parti_stats = NULL;	/* partition statistics */
int *str_length = NULL;	/* the length of each string */
int *str_height = NULL;	/* the height of each string */
int *x_sizes = NULL;		/* the max x size of each partition */
int *y_sizes = NULL;		/* the max y size of each partition */
int *x_positions = NULL;	/* and their postions, after placement */
int *y_positions = NULL;
int xfloor, yfloor;	/* the origin for the current partition */

mlist **partitions = NULL;	/* the set of PARTITIONS (lists) of modules */
tile **rootTiles = NULL;	/* The tile spaces that correspond to the partitions */
int partition_count;	/* the total number of partitions created */




#endif // #ifndef N2A_H